#include <stdio.h>
#include <math.h>
#include <omp.h>
#include <time.h>

void calc_pi_type1(int NUM_T);
void calc_pi_type2(int NUM_T);
void calc_pi_type3(int NUM_T);

int main(){
  int i;
  for(i=1;i<9;i++){
    calc_pi_type1(i);    
    calc_pi_type2(i);
    calc_pi_type3(i);    
  }
  return 0;
}

void calc_pi_type1(int NUM_T){
  int i_power = 17;
  double temp = pow(2.0,(double)i_power);
  int num_grid = (int)temp;
  //printf("%d\n",num_grid);
  
  double r_step = 1.0/((double)num_grid);
  double work = r_step*r_step*4.0;

  int i,j;
  double x0,y0,r0;
  double cal_pai = 0.0;

  int numPE = NUM_T;
  int array[numPE+1];
  int tmp = num_grid / numPE;
  for(i=0;i<numPE;i++){
    array[i] = tmp*i;
  }
  array[numPE] = num_grid;
  /*
  for(i=0;i<numPE+1;i++){
    printf("%d\n",array[i]);
  }
  */
  double sub_cal_pai[numPE];
  for(i=0;i<numPE;i++){
    sub_cal_pai[i] = 0.0;
  }

  struct timespec ts1,ts0;
  double diff;
  int rett;
  long diff_ns;
  
  rett = timespec_get(&ts0,TIME_UTC);  //計測開始
  
  omp_set_num_threads(NUM_T);
#pragma omp parallel
  {
    //omp parallelのなかで宣言すれば、privateになる
    int ii,jj;
    double xx0,yy0,rr0;
    int coreid;
    double temp = 0.0;
    
    coreid = omp_get_thread_num();
    //printf("%d\n",coreid);    
    for(ii=array[coreid]+1;ii<array[coreid+1]+1;ii++){
      for(jj=1;jj<num_grid+1;jj++){
	xx0 = ((double)ii) * r_step - r_step*0.5;
	yy0 = ((double)jj) * r_step - r_step*0.5;
	rr0 =xx0*xx0 + yy0*yy0;
        //if(rr0 < 1.0) sub_cal_pai[coreid] += work;
	if(rr0 < 1.0) temp += work;
      }
    }
    sub_cal_pai[coreid] = temp;  
  }
    
  for(i=0;i<numPE;i++){
    cal_pai += sub_cal_pai[i];
  }  
  printf("%e\n",cal_pai);
  
  rett = timespec_get(&ts1,TIME_UTC);
  diff = difftime(ts1.tv_sec,ts0.tv_sec);
  diff_ns = ts1.tv_nsec - ts0.tv_nsec;
  FILE *fp;
  fp = fopen("result/case1.dat","a");
  fprintf(fp,"%d %f s\n",NUM_T,diff+(double)diff_ns / 1000000000);
  fclose(fp);
}

void calc_pi_type2(int NUM_T){
  int i_power = 17;
  double temp = pow(2.0,(double)i_power);
  int num_grid = (int)temp;
  //printf("%d\n",num_grid);
  
  double r_step = 1.0/((double)num_grid);
  double work = r_step*r_step*4.0;

  int i,j;
  double x0,y0,r0;
  double cal_pai = 0.0;

  int numPE = NUM_T;
  int array[numPE+1];
  int tmp = num_grid / numPE;
  for(i=0;i<numPE;i++){
    array[i] = tmp*i;
  }
  array[numPE] = num_grid;
  /*
  for(i=0;i<numPE+1;i++){
    printf("%d\n",array[i]);
  }
  */
  double sub_cal_pai[numPE];
  for(i=0;i<numPE;i++){
    sub_cal_pai[i] = 0.0;
  }

  struct timespec ts1,ts0;
  double diff;
  int rett;
  long diff_ns;
  
  rett = timespec_get(&ts0,TIME_UTC);  //計測開始
  
  omp_set_num_threads(NUM_T);
#pragma omp parallel
  {
    //omp parallelのなかで宣言すれば、privateになる
    int ii,jj;
    double xx0,yy0,rr0;
    int coreid;
    //double temp = 0.0;
    
    coreid = omp_get_thread_num();
    //printf("%d\n",coreid);    
    for(ii=array[coreid]+1;ii<array[coreid+1]+1;ii++){
      for(jj=1;jj<num_grid+1;jj++){
	xx0 = ((double)ii) * r_step - r_step*0.5;
	yy0 = ((double)jj) * r_step - r_step*0.5;
	rr0 =xx0*xx0 + yy0*yy0;
        if(rr0 < 1.0) sub_cal_pai[coreid] += work;
	//if(rr0 < 1.0) temp += work;
      }
    }
    //sub_cal_pai[coreid] = temp;  
  }
    
  for(i=0;i<numPE;i++){
    cal_pai += sub_cal_pai[i];
  }  
  printf("%e\n",cal_pai);
  
  rett = timespec_get(&ts1,TIME_UTC);
  diff = difftime(ts1.tv_sec,ts0.tv_sec);
  diff_ns = ts1.tv_nsec - ts0.tv_nsec;

  FILE *fp;
  fp = fopen("result/case2.dat","a");
  fprintf(fp,"%d %f s\n",NUM_T,diff+(double)diff_ns / 1000000000);
  fclose(fp);  
}

void calc_pi_type3(int NUM_T){
  int i_power = 17;
  double temp = pow(2.0,(double)i_power);
  int num_grid = (int)temp;
  //printf("%d\n",num_grid);
  
  double r_step = 1.0/((double)num_grid);
  double work = r_step*r_step*4.0;

  int i,j;
  double x0,y0,r0;
  double cal_pai = 0.0;

  int numPE = NUM_T;
  int array[numPE+1];
  int tmp = num_grid / numPE;
  for(i=0;i<numPE;i++){
    array[i] = tmp*i;
  }
  array[numPE] = num_grid;
  /*
  for(i=0;i<numPE+1;i++){
    printf("%d\n",array[i]);
  }
  */
  double sub_cal_pai[numPE];
  for(i=0;i<numPE;i++){
    sub_cal_pai[i] = 0.0;
  }

  struct timespec ts1,ts0;
  double diff;
  int rett;
  long diff_ns;
  
  rett = timespec_get(&ts0,TIME_UTC);  //計測開始
  
  omp_set_num_threads(NUM_T);
  int ii,jj;
  double xx0,yy0,rr0;  
#pragma omp parallel for private(ii,jj,xx0,yy0,rr0) reduction(+: cal_pai)
  { 
    for(ii=1;ii<num_grid+1;ii++){
      for(jj=1;jj<num_grid+1;jj++){
	xx0 = ((double)ii) * r_step - r_step*0.5;
	yy0 = ((double)jj) * r_step - r_step*0.5;
	rr0 =xx0*xx0 + yy0*yy0;
        if(rr0 < 1.0) cal_pai += work;
      }
    } 
  }

  printf("%e\n",cal_pai);
  
  rett = timespec_get(&ts1,TIME_UTC);
  diff = difftime(ts1.tv_sec,ts0.tv_sec);
  diff_ns = ts1.tv_nsec - ts0.tv_nsec;
  FILE *fp;
  fp = fopen("result/case3.dat","a");
  fprintf(fp,"%d %f s\n",NUM_T,diff+(double)diff_ns / 1000000000);
  fclose(fp);   
  
}
