PROGRAM gapeuler1
!*********************** 013_pai_mp_seed_ifort.f90 ************************
!*    This is training program for                                        *
!*                                                                        *
!**************************************************************************

  !$ use omp_lib

  implicit  none

!=== Common variables
  integer   :: io_err
  integer   :: iy2,iy4,im2,id2,ih2,iz2,imi,idoy,jst,utc,ieom
  integer*8 :: n,n0,n1,n2,n3,n4,n5,n6,n7,n8,n9,n10
  integer   :: i,i0,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10
  integer   :: j,j0,j1,j2,j3,j4,j5,j6,j7,j8,j9,j10
  integer   :: k,k0,k1,k2,k3,k4,k5,k6,k7,k8,k9,k10
  real*8    :: r,r0,r1,r2,r3,r4,r5,r6,r7,r8,r9,r10
  character :: cy2*2,cy4*4,cm2*2,cd2*2,ch2*2,cz2*2,cymd8*8,chms6*6
  character :: c1*1,c2*2,c3*3,c4*4,c5*5,c6*6,c7*7,c8*8,c9*9,c10*10

!=== parameters
  integer              :: i_power = 17                        ! 2**i_power
! integer              :: i_power = 17                        ! 2**i_power
  real * 8             :: r_step
  integer              :: num_grid

!=== Constant
  real * 8, parameter  :: pai = 3.141592653589793238d0        ! {x̗Lg؂

!=== Time mesuremnets =========================================
  integer*8 :: time_begin_c, time_end_c, CountPerSec, CountMax
  real      :: elapsed_time
  real      :: time_single
!==============================================================

!=== variables for calculation
  real*8    :: x0, y0
  real*8    :: work
  real*8    :: cal_pai
  integer   :: num_threads

!=== Open output file
  open(21,file="./out_data/013_mp_sepped_ifort.dat", status='unknown')
  write(21,'("Program: /pai_K_mp/program_f90/013_pai_mp_seed_ifort.f90")')
  write(21,'("Compiler: ifort on Windows 11")')


!=== Preparation
  num_grid = 2**i_power
  r_step = 1.0d0/dble(num_grid)
  work = r_step*r_step*4.0d0

  write(*,*)
  write(*,'("   i_power =",i4)') i_power
  write(*,'("  num_grid =",i9)') num_grid

!==== Case 1
  write(*, *)
  write(21,*)
  write(*,'("=== case 1: Not use omp")')
  write(21,'("=== case 1: Not use omp")')
  write(21,'("threads power number",8x,"cal_pai",9x,"err  time_sec efficiency")')

  call system_clock(time_begin_c, CountPerSec, CountMax)
! write(*,*) time_begin_c, CountPerSec,CountMax, CountMax/CountPerSec

  cal_pai = 0.0d0

  do i = 1, num_grid
  do j = 1, num_grid
     x0 = dble(i)*r_step - r_step*0.5d0
     y0 = dble(j)*r_step - r_step*0.5d0

     r0 = x0*x0 + y0*y0

     if(r0 < 1.000d0) cal_pai = cal_pai + work
     !cal_pai = cal_pai + work
  enddo
  enddo

  call system_clock(time_end_c)
  elapsed_time = real(time_end_c - time_begin_c)/CountPerSec    ! [sec]

  time_single = elapsed_time

  num_threads = 0
  r1 = 1
  write(21,'(i2.2,i3.2,i9.6,f21.18,ES12.4,ES12.4,f8.4)') &
           num_threads, i_power, num_grid, cal_pai, (cal_pai - pai), elapsed_time, r1
!================================================================ end of case 1

!==== Case 2
  write(21,*)
  write(21,'("=== Case 2: use OpenMP 1")')
  write(*, '("=== Case 2: use OpenMP 1")')
  write(21,'("threads power number",8x,"cal_pai",9x,"err  time_sec efficiency")')

  do num_threads = 1, 8

!--- Set num_threads
    call omp_set_num_threads(num_threads)
    call system_clock(time_begin_c, CountPerSec, CountMax)

!--- Ouput parameters
    cal_pai = 0.0d0

    !$omp parallel do default(none) shared(num_grid,r_step,work) private(i,j, x0,y0,r0) reduction(+:cal_pai)
    do i = 1, num_grid
    do j = 1, num_grid
       x0 = dble(i)*r_step - r_step*0.5d0
       y0 = dble(j)*r_step - r_step*0.5d0

       r0 = x0*x0 + y0*y0

       if(r0 < 1.0d0) cal_pai = cal_pai + work
       !cal_pai = cal_pai + work
    enddo
    enddo
    !$omp end parallel do

    call system_clock(time_end_c)
    elapsed_time = real(time_end_c - time_begin_c)/CountPerSec    ! [sec]
    r1 = time_single/elapsed_time

    write(21,'(i2.2,i3.2,i9.6,f21.18,ES12.4,ES12.4,f8.4)') &
               num_threads, i_power, num_grid, cal_pai, (cal_pai - pai), elapsed_time, r1

  enddo ! end of num_threadsr-loop of case 2
!================================================================ end of case 2


!==== Case 3
  write(21,*)
  write(21,'("=== Case 3: use OpenMP 2")')
  write(*,' ("=== Case 3: use OpenMP 2")')
  write(21,'("threads power number",8x,"cal_pai",9x,"err  time_sec efficiency")')

  do num_threads = 1, 8

!--- Set num_threads
    call omp_set_num_threads(num_threads)
    call system_clock(time_begin_c, CountPerSec, CountMax)

!--- Ouput parameters
    cal_pai = 0.0d0

    do i = 1, num_grid
    !$omp parallel do default(none) shared(i,num_grid,r_step,work) private(j, x0,y0,r0) reduction(+:cal_pai)
    do j = 1, num_grid
       x0 = dble(i)*r_step - r_step*0.5d0
       y0 = dble(j)*r_step - r_step*0.5d0

       r0 = x0*x0 + y0*y0

       if(r0 < 1.0d0) cal_pai = cal_pai + work
       !cal_pai = cal_pai + work
    enddo
    !$omp end parallel do
    enddo

    call system_clock(time_end_c)
    elapsed_time = real(time_end_c - time_begin_c)/CountPerSec    ! [sec]
    r1 = time_single/elapsed_time

    write(21,'(i2.2,i3.2,i9.6,f21.18,ES12.4,ES12.4,f8.4)') &
               num_threads, i_power, num_grid, cal_pai, (cal_pai - pai), elapsed_time, r1

  enddo ! end of num_threadsr-loop of case 3
!================================================================ end of case 3

  stop
  end PROGRAM gapeuler1
